function BSensor(_name, _id, _type, in_satel) {
    this.name = 'bSens_' + _name + '_' + _id + '_' + _type;
    this.id = _id;
    //type of BSensor is position in objBSensors
    this.type = _type;        
    //satel object which contains sensor                   
    this.satel = in_satel;       
    //command to send                      
    this.cmd = objBSensorsNames[_type].cmd;      
    
    //add command in satel.bSensors
    if (this.satel.bSensors.indexOf(this.cmd) == -1){
        this.satel.bSensors.push(this.cmd);
    }
    
    this.widget = IR.GetPopup("bSensorWidget").Clone('bSens_' + _name + '_' + _id + '_' + _type);
    this.icon = this.widget.GetItem("sensor").GetState(0);
    this.widget.GetItem("name").Text = _name; 
    this.widget.GetItem("id").Text = _id;
    this.widget.GetItem("type").Text = _type;
    
    //check sensor state
    IR.SetInterval(1000, function(){
        if (this.cmd in this.satel.recievedBSensors){
            var sensor = checkState(this.satel.recievedBSensors[this.cmd], this.id);
            this.icon.TextColor = sensor ? 0x39B54AFF : 0xE53935FF;
            //=================FEEDBACK==========================================
             var value = sensor ? 1 : 0;
             IR.GetDevice('Custom Driver').SetFeedback(this.name, value);
            //===================================================================
        }
    }, this)
           
    this.satel.mainList.AddPopup(this.widget);
};

//==========================================================================================

//bSensors types and their commands
var objBSensorsNames =  [
    {cmd: 0x09,    name: "Armed partitions (suppressed)"},
    {cmd: 0x0A,    name: "Armed partitions (really)"},
    {cmd: 0x0B,    name: "Partitions armed in mode 2"},
    {cmd: 0x0C,    name: "Partitions armed in mode 3"},
    {cmd: 0x0D,    name: "Partitions with 1st code entered"},
    {cmd: 0x0E,    name: "Partitions entry time"},
    {cmd: 0x0F,    name: "Partitions exit time >10s"},
    {cmd: 0x10,    name: "Partitions exit time <10s"},
    {cmd: 0x11,    name: "Partitions temporary blocked"},
    {cmd: 0x12,    name: "Partitions blocked for guard round"},
    {cmd: 0x13,    name: "Partitions alarm"},
    {cmd: 0x14,    name: "Partitions fire alarm"},
    {cmd: 0x15,    name: "Partitions alarm memory"},
    {cmd: 0x16,    name: "Partitions fire alarm memory"},
    {cmd: 0x17,    name: "Output states"},
    {cmd: 0x26,    name: "Zones isolate"},
    {cmd: 0x28,    name: "Zones masked"},
    {cmd: 0x29,    name: "Zones masked memory"},
    {cmd: 0x00,    name: "Zones violation"},
    {cmd: 0x01,    name: "Zones tamper"},
    {cmd: 0x02,    name: "Zones alarm"},
    {cmd: 0x03,    name: "Zones tamper alarm"},
    {cmd: 0x04,    name: "Zones alarm memory"},
    {cmd: 0x05,    name: "Zones tamper alarm memory"},
    {cmd: 0x06,    name: "Zones bypass"},
    {cmd: 0x07,    name: "Zones 'no violation' trouble"},
    {cmd: 0x08,    name: "Zones 'long violation' trouble"}  ]
    
//commands of binary sensors and their data to send
var objBSensorsData =  {
    0x00: [0xfe, 0xfe, 0x00, 0xd7, 0xe2, 0xfe, 0x0d],
    0x01: [0xfe, 0xfe, 0x01, 0xd7, 0xe3, 0xfe, 0x0d],
    0x02: [0xfe, 0xfe, 0x02, 0xd7, 0xe4, 0xfe, 0x0d],
    0x03: [0xfe, 0xfe, 0x03, 0xd7, 0xe5, 0xfe, 0x0d],
    0x04: [0xfe, 0xfe, 0x04, 0xd7, 0xe6, 0xfe, 0x0d],
    0x05: [0xfe, 0xfe, 0x05, 0xd7, 0xe7, 0xfe, 0x0d],
    0x06: [0xfe, 0xfe, 0x06, 0xd7, 0xe8, 0xfe, 0x0d],
    0x07: [0xfe, 0xfe, 0x07, 0xd7, 0xe9, 0xfe, 0x0d],
    0x08: [0xfe, 0xfe, 0x08, 0xd7, 0xea, 0xfe, 0x0d],
    0x09: [0xfe, 0xfe, 0x09, 0xd7, 0xeb, 0xfe, 0x0d],
    0x0A: [0xfe, 0xfe, 0x0A, 0xd7, 0xec, 0xfe, 0x0d],
    0x0B: [0xfe, 0xfe, 0x0B, 0xd7, 0xed, 0xfe, 0x0d],
    0x0C: [0xfe, 0xfe, 0x0C, 0xd7, 0xee, 0xfe, 0x0d],
    0x0D: [0xfe, 0xfe, 0x0D, 0xd7, 0xef, 0xfe, 0x0d],
    0x0E: [0xfe, 0xfe, 0x0E, 0xd7, 0xf0, 0xfe, 0x0d],
    0x0F: [0xfe, 0xfe, 0x0F, 0xd7, 0xf1, 0xfe, 0x0d],
    0x10: [0xfe, 0xfe, 0x10, 0xd7, 0xf2, 0xfe, 0x0d],
    0x11: [0xfe, 0xfe, 0x11, 0xd7, 0xf3, 0xfe, 0x0d],
    0x12: [0xfe, 0xfe, 0x12, 0xd7, 0xf4, 0xfe, 0x0d],
    0x13: [0xfe, 0xfe, 0x13, 0xd7, 0xf5, 0xfe, 0x0d],
    0x14: [0xfe, 0xfe, 0x14, 0xd7, 0xf6, 0xfe, 0x0d],
    0x15: [0xfe, 0xfe, 0x15, 0xd7, 0xf7, 0xfe, 0x0d],
    0x16: [0xfe, 0xfe, 0x16, 0xd7, 0xf8, 0xfe, 0x0d],
    0x17: [0xfe, 0xfe, 0x17, 0xd7, 0xf9, 0xfe, 0x0d],
    0x26: [0xfe, 0xfe, 0x26, 0xd8, 0x08, 0xfe, 0x0d],
    0x28: [0xfe, 0xfe, 0x28, 0xd8, 0x0A, 0xfe, 0x0d],
    0x29: [0xfe, 0xfe, 0x29, 0xd8, 0x0B, 0xfe, 0x0d]  }
 