//insert here your Integra user password
var PASSWORD = '1111';

//convert password to binary form
var pass = [];   
for(var i = 0; i < 16; i = i + 2)
{
    if(PASSWORD.charAt(i+1) == ""){
        if(PASSWORD.charAt(i) == "")
            pass.push(0xFF)
        else
            pass.push(parseInt(PASSWORD.charAt(i)+"F", 16) & 0xff)   
    } 
    else
        pass.push(parseInt(PASSWORD.charAt(i)+PASSWORD.charAt(i+1), 16) & 0xff)      
}

IR.AddListener(IR.EVENT_START, 0, function()
{
    var satel = new Satel();
    satel.init();
      
    var mainList = IR.GetPage("mainPage").GetItem("list");
    mainList.Type = 3; 
    mainList.ScrollEnabled = false;
    mainList.ScrollBar = false;
        
    //menu template height
    var selectHeight = IR.GetPopup('selectTemplate').Height;
    
    /*
    * You can add widgets HERE:
    * name - title of vidget,
    * id -  id (#of partition or zone),
    * type (BSensor) - position in objBSensorsNames, 
    * type (Button) - position in objButtons,
    * activeMode - used alarm modes, 0 - inactive, 1 - active: [0,0,0,1]
    * nameMode - custom names for alarm modes: ['abc','bcd','cde','def']
    * satel.addBSensor('name', id, type);                               //binary Sensor
    * satel.addButton('name', id, type);                                //button
    * satel.addSecurity('name', id, [activeMode], [nameMode]);          //security
    * satel.addRelay('name', id);                                       //relay
    * satel.addTSensor('name', id);                                     //temperature sensor
    */    
    
    //examples 
    //satel.addTSensor('Termo Sensor', 1);
    //satel.addBSensor('Binary sensor ', 14, 0);
    //satel.addButton('Button', 3, 0); 
    //satel.addSecurity('Security', 4, [1,0,1,0], ['a', 'b', 'c', 'd']);
    //satel.addRelay('Relay', 5);

    //feedback listener
    IR.AddListener(IR.EVENT_TAG_CHANGE, IR.GetDevice('Custom Driver'), function(in_sName, in_sValue){
      //IR.Log('Name: ' + in_sName + ', Value: ' + in_sValue);
    })

    //ADD main
    IR.AddListener(IR.EVENT_ITEM_RELEASE, IR.GetPage("mainPage").GetItem("btnAdd"), function(){
        IR.ShowPopup("addTypeSelect");
    });
    
//=================================ADD TYPE SELECT===========================================
    
    var addTypeSelect = IR.GetPopup("select").Clone("addTypeSelect");
    
    //CANCEL
    IR.AddListener(IR.EVENT_ITEM_RELEASE, addTypeSelect.GetItem("cancel"), function(){
        IR.HidePopup("addTypeSelect");
    });    
    
    var typeList = addTypeSelect.GetItem("list");
    typeListBG = addTypeSelect.GetItem("panel rounded");
    typeList.ScrollBar = false;
    typeList.ScrollEnabled = false;
    
    //filling list in typeSelect
    var typeListItems = [{name: 'Binary Sensor', value: '',     visible: false},
                         {name: 'Button',        value: '',     visible: false},
                         {name: 'Security',      value: '',     visible: false},
                         {name: 'Relay',         value: '',     visible: false},
                         {name: 'Termo Sensor',  value: '',     visible: false}];
    
    fillList(typeList, 'selectTemplate', typeListItems, typeListBG);
    
    //SELECT typeList
    IR.AddListener(IR.EVENT_ITEM_SELECT, typeList, function(item){
        switch (item){
            case 0:
                HideShow('addTypeSelect', 'addBSensor');           
                break; 
            case 1:
                HideShow('addTypeSelect', 'addButton');           
                break;
            case 2:
                HideShow('addTypeSelect', 'addSecurity');           
                break;
            case 3:
                HideShow('addTypeSelect', 'addRelay');           
                break;
            case 4:
                HideShow('addTypeSelect', 'addTSensor')
        }
    }); 
 
 
//===========================================================================================
//                                 BINARY SENSOR
//===========================================================================================                                                                                                           
    
    
    var addBSensor = IR.GetPopup('select').Clone('addBSensor');
    var addBSensorList = addBSensor.GetItem('list');
    var addBSensorBG = addBSensor.GetItem('panel rounded');
    addBSensor.GetItem('title').Text = 'Binary sensor';
    addBSensor.GetItem('done').Visible = true;

    //current sensor for adding: name, id, type
    var newSensor = {};  
    
    //menus items
    var addBSensorFields =        [{name: 'Name',        value: 'Input Name',            visible: true},
                                   {name: 'ID',           value: 'Input ID',                  visible: true},
                                {name: 'Mode',         value: 'Not selected',      visible: true}];
                                   
    fillList(addBSensorList, 'selectTemplate', addBSensorFields, addBSensorBG);

    var addBSensorMenu =     {'name': addBSensorList.GetItemByIndex(0).Popup,
                              'id':   addBSensorList.GetItemByIndex(1).Popup,
                              'mode': addBSensorList.GetItemByIndex(2).Popup}
    
    //CANCEL addBSensor
    IR.AddListener(IR.EVENT_ITEM_RELEASE, addBSensor.GetItem("cancel"), function(){
        HideShow('addBSensor', 'addTypeSelect');
    });

    //DONE addBsensor
    IR.AddListener(IR.EVENT_ITEM_PRESS, addBSensor.GetItem('done'), function(){
        if (newSensor.name == undefined || newSensor.id == undefined || newSensor.type == undefined){
            showError("Check the inputs", "addBSensor");
        } else {
            satel.addBSensor(newSensor.name, newSensor.id, newSensor.type);
            //reset the variable add window
            newSensor = {};
            resetList(addBSensorList, addBSensorFields);
            IR.HideAllPopups("");
        }
    });     
    
    //SELECT addBSensorList
    IR.AddListener(IR.EVENT_ITEM_SELECT, addBSensorList, function(item){
        switch(item){
            case 0:
                //name
                HideShow('addBSensor', 'binaryNameInput');
                if (newSensor.name){
                    binaryNameInput.GetItem('edit').Text = newSensor.name;
                } else {
                    binaryNameInput.GetItem('edit').Text = '';    
                }
                break;
            case 1:
                //ID
                HideShow('addBSensor', 'binaryIdInput');
                if (newSensor.id){
                    binaryIdInput.GetItem("edit").Text = newSensor.id;
                } else {
                    binaryIdInput.GetItem("edit").Text = '';
                }
                break;
            case 2:
                //mode
                HideShow("addBSensor", "binaryModeSelect");
                break;
        }
    });    
   
//=================================NEW BINARY SENSOR MODE SELECT=============================
    
                
    var binaryModeSelect = IR.GetPopup("select").Clone("binaryModeSelect");
    binaryModeSelect.GetItem('title').Text = 'Select sensor mode';
    var binaryModeSelectList = binaryModeSelect.GetItem("list");
    var binaryModeSelectBG = binaryModeSelect.GetItem("panel rounded");
    
    fillList(binaryModeSelectList, 'selectTemplate', objBSensorsNames, binaryModeSelectBG);
    
    //SELECT binaryModeSelectList
    IR.AddListener(IR.EVENT_ITEM_SELECT, binaryModeSelectList, function(item){  
        newSensor.type =  item;
        addBSensorMenu['mode'].GetItem('value').Text = 'Selected';
        HideShow("binaryModeSelect", "addBSensor"); 
    });
    
    //CANCEL binaryModeSelect
    IR.AddListener(IR.EVENT_ITEM_RELEASE, binaryModeSelect.GetItem("cancel"), function(){
        HideShow("binaryModeSelect", "addBSensor");
    });
       
//=================================NEW BINARY SENSOR ID INPUT================================

    var binaryIdInput = IR.GetPopup("input").Clone("binaryIdInput");
    binaryIdInput.GetItem("label").Text = "Input sensor ID";
    
    //DONE binaryIdInput
    IR.AddListener(IR.EVENT_ITEM_PRESS, binaryIdInput.GetItem("done"), function(){
        var editBox = binaryIdInput.GetItem("edit");
        var id = Number(editBox.Text);
        if (id < 1 || id > 128){
            editBox.Text = '';
            showError('ID must be 1 - 128', 'binaryIdInput'); 
        } else {
            if (isNaN(id)){
                editBox.Text = '';
                showError('Its not a number', 'binaryIdInput');
            } else {
                newSensor.id = id;
                HideShow('binaryIdInput', 'addBSensor');
                addBSensorMenu['id'].GetItem('value').Text = id;
            }
        }
    });
    
    //CANCEL binaryIdInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, binaryIdInput.GetItem("cancel"), function(){
        HideShow("binaryIdInput", "addBSensor");
    });
    

//=================================NEW BINARY SENSOR NAME INPUT==============================

    var binaryNameInput = IR.GetPopup("input").Clone("binaryNameInput");
    binaryNameInput.GetItem("label").Text = "Input sensor name";
    
    //CANCEL binaryNameInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, IR.GetPopup("binaryNameInput").GetItem("cancel"), function(){
        HideShow("binaryNameInput", "addBSensor");
    });
    
    //DONE binaryNameInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, IR.GetPopup("binaryNameInput").GetItem("done"), function(){      
        var name = IR.GetPopup("binaryNameInput").GetItem("edit").Text;
        if (name == ''){
             showError('Name is empty', 'binaryNameInput');
        } else { 
             newSensor.name = name;
             HideShow("binaryNameInput", "addBSensor");
             addBSensorMenu['name'].GetItem('value').Text = name;
        }
    });
           
//===========================================================================================
//                                 BUTTON
//===========================================================================================
    
    //current button for add: name, id, type
    var newButton = {};           
    
    var addButton = IR.GetPopup('select').Clone('addButton');
    var addButtonList = addButton.GetItem('list');
    var addButtonBG = addButton.GetItem('panel rounded');
    addButton.GetItem('title').Text = 'Button';
    addButton.GetItem('done').Visible = true; 
    
    //menu items
    var addButtonFields =        [{name: 'Name',        value: 'Input Name',            visible: true},
                                   {name: 'ID',           value: 'Input ID',                  visible: true},
                                {name: 'Mode',         value: 'Not selected',      visible: true}];
                                   
    fillList(addButtonList, 'selectTemplate', addButtonFields, addButtonBG);

    var addButtonMenu =     {'name': addButtonList.GetItemByIndex(0).Popup,
                              'id':   addButtonList.GetItemByIndex(1).Popup,
                              'mode': addButtonList.GetItemByIndex(2).Popup}
    
    //DONE addButton
    IR.AddListener(IR.EVENT_ITEM_PRESS, addButton.GetItem('done'), function(){
        if (newButton.name == undefined || newButton.id == undefined || newButton.type == undefined){
            showError("Check the inputs", "addButton");
        } else {
            satel.addButton(newButton.name, newButton.id, newButton.type);
            //reset the variable add window
            newButton = {};
            resetList(addButtonList, addButtonFields);
            IR.HideAllPopups("");
        }
    }) 

    //SELECT addButtonList
    IR.AddListener(IR.EVENT_ITEM_SELECT, addButtonList, function(item){
        switch(item){
            case 0:
                //name
                HideShow('addButton', 'btnNameInput');
                if (newButton.name){
                    btnNameInput.GetItem('edit').Text = newButton.name;
                } else {
                    btnNameInput.GetItem('edit').Text = '';    
                }
                break;
            case 1:
                //ID
                HideShow('addButton', 'btnIdInput');
                if (newButton.id){
                    btnIdInput.GetItem("edit").Text = newButton.id;
                } else {
                    btnIdInput.GetItem("edit").Text = '';
                }
                break;
            case 2:
                //mode
                HideShow("addButton", "btnModeSelect");
                break;
        }
    });

    //CANCEL addButton
    IR.AddListener(IR.EVENT_ITEM_RELEASE, addButton.GetItem("cancel"), function(){
        HideShow('addButton', 'addTypeSelect');
    });

//=================================NEW BUTTON MODE SELECT====================================
         
    var btnModeSelect = IR.GetPopup("select").Clone("btnModeSelect");
    binaryModeSelect.GetItem('title').Text = 'Select button mode';
    var btnModeSelectList = btnModeSelect.GetItem("list");
    var btnModeSelectBG = btnModeSelect.GetItem("panel rounded");
    
    fillList(btnModeSelectList, 'selectTemplate', objButtons, btnModeSelectBG);
    
    //SELECT btnModeSelectList
    IR.AddListener(IR.EVENT_ITEM_SELECT, btnModeSelectList, function(item){  
        newButton.type =  item;
        addButtonMenu['mode'].GetItem('value').Text = 'Selected';
        HideShow("btnModeSelect", "addButton"); 
    });
    
    //CANCEL btnModeSelect
    IR.AddListener(IR.EVENT_ITEM_RELEASE, btnModeSelect.GetItem("cancel"), function(){
        HideShow("btnModeSelect", "addButton");
    });
      
//=================================NEW BUTTON ID INPUT=======================================

    var btnIdInput = IR.GetPopup("input").Clone("btnIdInput");
    btnIdInput.GetItem("label").Text = "Input button ID";
    
    //DONE btnIdInput
    IR.AddListener(IR.EVENT_ITEM_PRESS, btnIdInput.GetItem("done"), function(){
        var editBox = btnIdInput.GetItem("edit");
        var id = Number(editBox.Text);
        if (id < 1 || id > 128){
            editBox.Text = '';
            showError('ID must be 1 - 128', 'btnIdInput'); 
        } else {
            if (isNaN(id)){
                editBox.Text = '';
                showError('Its not a number', 'btnIdInput');
            } else {
                newButton.id = id;
                HideShow('btnIdInput', 'addButton');
                addButtonMenu['id'].GetItem('value').Text = id;
            }
        }
    });
    
    //CANCEL btnIdInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, btnIdInput.GetItem("cancel"), function(){
        HideShow("btnIdInput", "addButton");
    });

//=================================NEW BUTTON NAME INPUT=====================================
    
    var btnNameInput = IR.GetPopup("input").Clone("btnNameInput");
    btnNameInput.GetItem("label").Text = "Input button name";
    
    //DONE btnNameInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, IR.GetPopup("btnNameInput").GetItem("done"), function(){      
        var name = IR.GetPopup("btnNameInput").GetItem("edit").Text;
        if (name == ''){
             showError('Name is empty', 'btnNameInput');
        } else { 
             newButton.name = name;
             HideShow("btnNameInput", "addButton");
             addButtonMenu['name'].GetItem('value').Text = name;
        }
    });  

    //CANCEL btnNameInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, IR.GetPopup("btnNameInput").GetItem("cancel"), function(){
        HideShow("btnNameInput", "addButton");
    });

//===========================================================================================
//                                                    SECURITY
//===========================================================================================

    //current security widget for adding: name, id, modes, btnNames        
    var newSecurity = {};

    var addSecurity = IR.GetPopup('select').Clone('addSecurity');
    var addSecurityList = addSecurity.GetItem('list');
    var addSecurityBG = addSecurity.GetItem('panel rounded');
    addSecurity.GetItem('title').Text = 'Security';
    addSecurity.GetItem('done').Visible = true; 

    var addSecurityFields =        [{name: 'Name',              value: 'Input Name',    visible: true},
                                    {name: 'ID',                value: 'Input ID',      visible: true},
                                    {name: 'Active alarm modes',value: 'All',           visible: true},
                                    {name: 'Mode 0 name',       value: 'Mode 0',        visible: true},
                                    {name: 'Mode 1 name',       value: 'Mode 1',        visible: true},
                                    {name: 'Mode 2 name',       value: 'Mode 2',        visible: true},
                                    {name: 'Mode 3 name',       value: 'Mode 3',        visible: true}];

    fillList(addSecurityList, 'selectTemplate', addSecurityFields, addSecurityBG);

    var addSecurityMenu =     { 'name':     addSecurityList.GetItemByIndex(0).Popup,
                                'id':       addSecurityList.GetItemByIndex(1).Popup,
                                'modes':    addSecurityList.GetItemByIndex(2).Popup,
                                0:          addSecurityList.GetItemByIndex(3).Popup,
                                1:          addSecurityList.GetItemByIndex(4).Popup,
                                2:          addSecurityList.GetItemByIndex(5).Popup,
                                3:          addSecurityList.GetItemByIndex(6).Popup}
    
    //DONE addSecurity
    IR.AddListener(IR.EVENT_ITEM_PRESS, addSecurity.GetItem('done'), function(){
        if (newSecurity.name == undefined || newSecurity.id == undefined || !modeCheck(newSecurity.mode)){
            showError("Check the inputs", "addSecurity");
        } else {
            satel.addSecurity(newSecurity.name, newSecurity.id, newSecurity.mode, newSecurity.btnNames);
            //reset variable and add window
            newSecurity = {};
            newSecurity.mode = [1,1,1,1];
            newSecurity.btnNames = ['Mode 0', 'Mode 1', 'Mode 2', 'Mode 3'];
            resetList(addSecurityList, addSecurityFields);
            IR.HideAllPopups("");
        }
    }); 

    //which mode we are currently changing
    var currentEdit = 0;

    //SELECT addSecurityList
    IR.AddListener(IR.EVENT_ITEM_SELECT, addSecurityList, function(item){
        switch(item){
            case 0:
                //name
                HideShow('addSecurity', 'secNameInput');
                if (newSecurity.name){
                    secNameInput.GetItem('edit').Text = newButton.name;
                } else {
                    secNameInput.GetItem('edit').Text = '';    
                }
                break;
            case 1:
                //ID
                HideShow('addSecurity', 'secIdInput');
                if (newSecurity.id){
                    secIdInput.GetItem("edit").Text = newSecurity.id;
                } else {
                    secIdInput.GetItem("edit").Text = '';
                }
                break;
            case 2:
                //modes
                HideShow("addSecurity", "secModeSelect");
                secModeSelectList.Clear();
                fillList(secModeSelectList, 'selectCheckTemplate', objSecurityModes, 0);
                break;
            case 3:
                //mode0 rename
                currentEdit = 0;
                //check does this menu item active? 
                if (!addSecurityMenu[0].GetItem('fog').Visible)
                    HideShow('addSecurity', 'renameInput');
                renameInput.GetItem('edit').Text = newSecurity.btnNames[currentEdit];
                break;
            case 4:
                //mode1 rename
                currentEdit = 1;
                if (!addSecurityMenu[1].GetItem('fog').Visible)
                    HideShow('addSecurity', 'renameInput');
                renameInput.GetItem('edit').Text = newSecurity.btnNames[currentEdit];
                break;
            case 5:
                //mode2 rename
                currentEdit = 2;
                if (!addSecurityMenu[2].GetItem('fog').Visible)
                    HideShow('addSecurity', 'renameInput');
                renameInput.GetItem('edit').Text = newSecurity.btnNames[currentEdit];
                break;
            case 6:
                //mode3 rename
                currentEdit = 3;
                if (!addSecurityMenu[3].GetItem('fog').Visible)
                    HideShow('addSecurity', 'renameInput');
                renameInput.GetItem('edit').Text = newSecurity.btnNames[currentEdit];
                break;
        }
    });

    //CANCEL addSecurity
    IR.AddListener(IR.EVENT_ITEM_RELEASE, addSecurity.GetItem("cancel"), function(){
        HideShow('addSecurity', 'addTypeSelect');
    });


//=================================NEW SECURITY MODES SELECT=================================
    
    //security modes in use, default: all
    newSecurity.mode = [1,1,1,1];
    
    var secModeSelect =     IR.GetPopup('modesSelect').Clone("secModeSelect");
    var secModeSelectList = secModeSelect.GetItem("list");

    //select all
    var secSelectBtn = secModeSelect.GetItem('selectBtn');
    
    fillList(secModeSelectList, 'selectCheckTemplate', objSecurityModes, 0);
    

    //SELECT secModeSelectList
    IR.AddListener(IR.EVENT_ITEM_SELECT, secModeSelectList, function(item){        
        if (newSecurity.mode[item] == 1){
            newSecurity.mode[item] = 0;
            secModeSelectList.GetItemByIndex(item).Popup.GetItem("check").Visible = false;
        } else {
            newSecurity.mode[item] = 1;
            secModeSelectList.GetItemByIndex(item).Popup.GetItem("check").Visible = true;
        }
    });
    
    //check selected modes, you must to select at least 1 mode
    function modeCheck(data){
        var check = false;
        for (var i = 0; i < data.length; i++){
            if (data[i] == 1)
                check = true;      
        }
        return check;   
    }
       
    //SELECT_All
    IR.AddListener(IR.EVENT_ITEM_PRESS, secSelectBtn, function(){
        newSecurity.mode = [1,1,1,1];
        for (var i = 0; i < 4; i++){
            secModeSelectList.GetItemByIndex(i).Popup.GetItem("check").Visible = true;            
        }
    });
    
    //return a nonZero elements amount or all
    function nonZero(_arr){
        var count = 0;
        for (var i = 0; i < _arr.length; i++){
            if (_arr[i])
                count++
        }
        if (count == _arr.length) return 'All'
        return count;
    }


    //DONE secModeSelect
    IR.AddListener(IR.EVENT_ITEM_PRESS, secModeSelect.GetItem('done'), function(){
        if (!modeCheck(newSecurity.mode)){
            showError('Nothing is selected', 'secModeSelect');
        } else {
            addSecurityMenu.modes.GetItem('value').Text = nonZero(newSecurity.mode);
            //enabling/disabling menu items
            for (var i = 0; i < 4; i++){
                if (newSecurity.mode[i] == 0){
                    addSecurityMenu[i].GetItem('fog').Visible = true;
                } else {
                    addSecurityMenu[i].GetItem('fog').Visible = false;
                }            
            }
            HideShow("secModeSelect", "addSecurity");
        }
    })

    //CANCEL secModeSelect
    IR.AddListener(IR.EVENT_ITEM_RELEASE, secModeSelect.GetItem("cancel"), function(){
        HideShow('secModeSelect', "addSecurity");
    });

//=================================NEW SECURITY BUTTONS RENAME===============================

    //custom alarm modes names
    newSecurity.btnNames = ['Mode 0', 'Mode 1', 'Mode 2', 'Mode 3'];
    
    var renameInput =  IR.GetPopup("input").Clone("renameInput");
    renameInput.GetItem("label").Text = "Input new name";
    
    //CANCEL renameInput  
    IR.AddListener(IR.EVENT_ITEM_PRESS, renameInput.GetItem('cancel'), function(){
        HideShow('renameInput', 'addSecurity');
    });
      
    //DONE renameInput   
    IR.AddListener(IR.EVENT_ITEM_PRESS, renameInput.GetItem('done'), function(){
        var name = IR.GetPopup("renameInput").GetItem("edit").Text;
        if (name != ''){
            newSecurity.btnNames[currentEdit] = name;
            //change name in secAlarmRenameList 
            addSecurityMenu[currentEdit].GetItem('value').Text = name;
            HideShow("renameInput", "addSecurity");
        } else {
            showError('Name is empty', 'renameInput');
        }
    });   
    
//=================================NEW SECURITY ID INPUT=====================================
   
    var secIdInput = IR.GetPopup("input").Clone("secIdInput");
    secIdInput.GetItem("label").Text = "Input security ID";
    
    //DONE secIdInput
    IR.AddListener(IR.EVENT_ITEM_PRESS, secIdInput.GetItem("done"), function(){
        var editBox = secIdInput.GetItem("edit");
        var id = Number(editBox.Text);
        if (id < 1 || id > 32){
            editBox.Text = '';
            showError('ID must be 1 - 32', 'secIdInput'); 
        } else {
            if (isNaN(id)){
                editBox.Text = '';
                showError('Its not a number', 'secIdInput');
            } else {
                newSecurity.id = id;
                HideShow('secIdInput', 'addSecurity');
                addSecurityMenu['id'].GetItem('value').Text = id;
            }
        }
    });
    
    //CANCEL secIdInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, secIdInput.GetItem("cancel"), function(){
        HideShow("secIdInput", "addSecurity");
    });

//=================================NEW SECURITY NAME INPUT===================================
    
    var secNameInput = IR.GetPopup("input").Clone("secNameInput");
    secNameInput.GetItem("label").Text = "Input security name";
    
    //DONE secNameInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, IR.GetPopup("secNameInput").GetItem("done"), function(){      
        var name = IR.GetPopup("secNameInput").GetItem("edit").Text;
        if (name == ''){
             showError('Name is empty', 'secNameInput');
        } else { 
             newSecurity.name = name;
             HideShow("secNameInput", "addSecurity");
             addSecurityMenu['name'].GetItem('value').Text = name;
        }
    });  

    //CANCEL secNameInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, IR.GetPopup("secNameInput").GetItem("cancel"), function(){
        HideShow("secNameInput", "addSecurity");
    }); 

//===========================================================================================
//                                 RELAY
//===========================================================================================

    //current relay for adding: name, id 
    var newRelay = {};          
    
    var addRelay = IR.GetPopup('select').Clone('addRelay');
    var addRelayList = addRelay.GetItem('list');
    var addRelayBG = addRelay.GetItem('panel rounded');

    addRelay.GetItem('title').Text = 'Relay';
    addRelay.GetItem('done').Visible = true; 
    
    //menu items
    var addRelayFields =        [   {name: 'Name',  value: 'Input Name',    visible: true},
                                    {name: 'ID',    value: 'Input ID',      visible: true}  ];
                                   
    fillList(addRelayList, 'selectTemplate', addRelayFields, addRelayBG);

    var addRelayMenu =     {    'name': addRelayList.GetItemByIndex(0).Popup,
                                'id':   addRelayList.GetItemByIndex(1).Popup }
    
    //CANCEL addRelay
    IR.AddListener(IR.EVENT_ITEM_RELEASE, addRelay.GetItem("cancel"), function(){
        HideShow('addRelay', 'addTypeSelect');
    });

    //DONE addRelay
    IR.AddListener(IR.EVENT_ITEM_PRESS, addRelay.GetItem('done'), function(){
        if (newRelay.name == undefined || newRelay.id == undefined){
            showError("Check the inputs", "addRelay");
        } else {
            satel.addRelay(newRelay.name, newRelay.id);
            //reset variable and add window
            newRelay = {};
            resetList(addRelayList, addRelayFields);
            IR.HideAllPopups("");
        }
    });     
    
    //SELECT addRelayList
    IR.AddListener(IR.EVENT_ITEM_SELECT, addRelayList, function(item){
        switch(item){
            case 0:
                //name
                HideShow('addRelay', 'relayNameInput');
                if (newRelay.name){
                    relayNameInput.GetItem('edit').Text = newRelay.name;
                } else {
                    relayNameInput.GetItem('edit').Text = '';    
                }
                break;
            case 1:
                //ID
                HideShow('addRelay', 'relayIdInput');
                if (newRelay.id){
                    relayIdInput.GetItem("edit").Text = newRelay.id;
                } else {
                    relayIdInput.GetItem("edit").Text = '';
                }
                break;
        }
    });    

//=================================NEW RELAY ID INPUT========================================

    var relayIdInput = IR.GetPopup("input").Clone("relayIdInput");
    relayIdInput.GetItem("label").Text = "Input relay ID";
    
    //DONE relayIdInput
    IR.AddListener(IR.EVENT_ITEM_PRESS, relayIdInput.GetItem("done"), function(){
        var editBox = relayIdInput.GetItem("edit");
        var id = Number(editBox.Text);
        if (id < 1 || id > 128){
            editBox.Text = '';
            showError('ID must be 1 - 128', 'relayIdInput'); 
        } else {
            if (isNaN(id)){
                editBox.Text = '';
                showError('Its not a number', 'relayIdInput');
            } else {
                newRelay.id = id;
                HideShow('relayIdInput', 'addRelay');
                addRelayMenu['id'].GetItem('value').Text = id;
            }
        }
    });
    
    //CANCEL relayIdInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, relayIdInput.GetItem("cancel"), function(){
        HideShow("relayIdInput", "addRelay");
    });

//=================================NEW RELAY NAME INPUT======================================
    
    var relayNameInput = IR.GetPopup("input").Clone("relayNameInput");
    relayNameInput.GetItem("label").Text = "Input relay name";
    
    //DONE relayNameInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, IR.GetPopup("relayNameInput").GetItem("done"), function(){      
        var name = IR.GetPopup("relayNameInput").GetItem("edit").Text;
        if (name == ''){
             showError('Name is empty', 'relayNameInput');
        } else { 
             newRelay.name = name;
             HideShow("relayNameInput", "addRelay");
             addRelayMenu['name'].GetItem('value').Text = name;
        }
    });  

    //CANCEL relayNameInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, IR.GetPopup("relayNameInput").GetItem("cancel"), function(){
        HideShow("relayNameInput", "addRelay");
    });

//===========================================================================================
//                                 TERMO SENSOR
//===========================================================================================                                                                                                           
    
    
    var addTSensor = IR.GetPopup('select').Clone('addTSensor');
    var addTSensorList = addTSensor.GetItem('list');
    var addTSensorBG = addTSensor.GetItem('panel rounded');
    addTSensor.GetItem('title').Text = 'Termo sensor';
    addTSensor.GetItem('done').Visible = true;

    //current termo sensor for adding: name, id
    var newTSensor = {};
    
    //menu items
    var addTSensorFields =        [{name: 'Name',        value: 'Input Name',            visible: true},
                                   {name: 'ID',           value: 'Input ID',                  visible: true}];
                                   
    fillList(addTSensorList, 'selectTemplate', addTSensorFields, addTSensorBG);

    var addTSensorMenu =     {'name': addTSensorList.GetItemByIndex(0).Popup,
                              'id':   addTSensorList.GetItemByIndex(1).Popup}
    
    //CANCEL addTSensor
    IR.AddListener(IR.EVENT_ITEM_RELEASE, addTSensor.GetItem("cancel"), function(){
        HideShow('addTSensor', 'addTypeSelect');
    });

    //DONE addTSensor
    IR.AddListener(IR.EVENT_ITEM_PRESS, addTSensor.GetItem('done'), function(){
        if (newTSensor.name == undefined || newTSensor.id == undefined){
            showError("Check the inputs", "addTSensor");
        } else {
            satel.addTSensor(newTSensor.name, newTSensor.id);
            //reset variable and add window
            newTSensor = {};
            resetList(addTSensorList, addTSensorFields);
            IR.HideAllPopups("");
        }
    });     
    
    //SELECT addTSensorList
    IR.AddListener(IR.EVENT_ITEM_SELECT, addTSensorList, function(item){
        switch(item){
            case 0:
                //name
                HideShow('addTSensor', 'termoNameInput');
                if (newTSensor.name){
                    termoNameInput.GetItem('edit').Text = newTSensor.name;
                } else {
                    termoNameInput.GetItem('edit').Text = '';    
                }
                break;
            case 1:
                //ID
                HideShow('addTSensor', 'termoIdInput');
                if (newTSensor.id){
                    termoIdInput.GetItem("edit").Text = newTSensor.id;
                } else {
                    termoIdInput.GetItem("edit").Text = '';
                }
                break;
        }
    });    

//=================================NEW TERMO ID INPUT========================================

    var termoIdInput = IR.GetPopup("input").Clone("termoIdInput");
    termoIdInput.GetItem("label").Text = "Input relay ID";
    
    //DONE termoIdInput
    IR.AddListener(IR.EVENT_ITEM_PRESS, termoIdInput.GetItem("done"), function(){
        var editBox = termoIdInput.GetItem("edit");
        var id = Number(editBox.Text);
        if (id < 1 || id > 256){
            editBox.Text = '';
            showError('ID must be 1 - 256', 'termoIdInput'); 
        } else {
            if (isNaN(id)){
                editBox.Text = '';
                showError('Its not a number', 'termoIdInput');
            } else {
                newTSensor.id = id;
                HideShow('termoIdInput', 'addTSensor');
                addTSensorMenu['id'].GetItem('value').Text = id;
            }
        }
    });
    
    //CANCEL termoIdInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, termoIdInput.GetItem("cancel"), function(){
        HideShow("termoIdInput", "addTSensor");
    });

//=================================NEW TERMO NAME INPUT======================================
    
    var termoNameInput = IR.GetPopup("input").Clone("termoNameInput");
    termoNameInput.GetItem("label").Text = "Input relay name";
    
    //DONE termoNameInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, IR.GetPopup("termoNameInput").GetItem("done"), function(){      
        var name = IR.GetPopup("termoNameInput").GetItem("edit").Text;
        if (name == ''){
             showError('Name is empty', 'termoNameInput');
        } else { 
             newTSensor.name = name;
             HideShow("termoNameInput", "addTSensor");
             addTSensorMenu['name'].GetItem('value').Text = name;
        }
    });  

    //CANCEL termoNameInput
    IR.AddListener(IR.EVENT_ITEM_RELEASE, IR.GetPopup("termoNameInput").GetItem("cancel"), function(){
        HideShow("termoNameInput", "addTSensor");
    });

});