//relay title, zone id, satel object which contains relay
function Relay(in_sName, in_nId, in_satel){
    this.name = in_sName;
    this.id = in_nId;
    this.device = in_satel.device;
    this.satel = in_satel;
    
    //add 0x17 command to Satel, relay data stored as a binarySensor with 0x17 command   
    if (this.satel.bSensors.indexOf(0x17) == -1){     
        this.satel.bSensors.push(0x17);
    }
    
    //loading animation coordinates
    this.loadPosition = {off: 503, on: 545};   
    //trigger position
    this.state = 0;
    
    this.widget = IR.GetPopup("relayWidget").Clone(in_sName + '_' + Math.random().toString(36).slice(3,8));
    this.widget.GetItem("name").Text = this.name;
    this.widget.GetItem("id").Text = this.id;
    this.loading = this.widget.GetItem("loading");
    this.trigger = this.widget.GetItem("trigger");
    
    this.satel.mainList.AddPopup(this.widget);
    
    IR.SetInterval(1000, function(){
        if ( 0x17 in this.satel.recievedBSensors ){
            var check = checkState(this.satel.recievedBSensors[0x17], this.id);
            
            if (check != this.state){
                this.changeState();
            }
        }
    }, this)
    
    IR.AddListener(IR.EVENT_ITEM_PRESS, this.widget.GetItem('triggerBtn'), this.press, this);
}

//==========================================================================================

Relay.prototype.press = function(){
    this.showLoading();
    this.send();
}

//==========================================================================================

Relay.prototype.showLoading = function(){
    this.loading.X = this.state ? this.loadPosition.on : this.loadPosition.off;
    this.loading.Visible = true;
    IR.SetTimeout(4000, function(){
        this.hideLoading();
    }, this)
}

//==========================================================================================


Relay.prototype.hideLoading = function(){
    this.loading.Visible = false;
}

//==========================================================================================

Relay.prototype.send = function(){
    var cmd = this.state ? 0x89 : 0x88;
    var command = [];
    
    command.push(cmd);
            
    for (var i = 0; i < pass.length; i++){
        command.push(pass[i]);
    }
    var data = setBit(this.id, 16);      
    for (var i = 0; i < data.length; i++){
        command.push(data[i]);
    }
    sendFrame(command);
}

//==========================================================================================

Relay.prototype.changeState = function(){
    if (this.state){
        this.state = 0;
        this.hideLoading();
        this.widget.GetItem("trigger").Value = 0;            
    } else{
        this.state = 1;
        this.hideLoading();
        this.widget.GetItem("trigger").Value = 1;
    }    
}

//==========================================================================================

var objRelay = {
    outputsButton: {
    name: "Outputs button",
        on:   0x88,
        off:  0x89,
        data: 0x17
    }
}

