//modes - selected alarm modes, [1,0,1,0] - 1 - active, 0 - inactive
function Security(_name, _id, _modes, _btnNames, _list){
    this.name = _name + Math.random().toString(36).slice(3,8);
    this.id = _id;
    this.modes = [];
    this.btnNames = [];
    this.data = setBit(this.id, 4);
    
    this.widget = IR.GetPopup("securityWidget").Clone('sec_' + this.name + '_' + this.id);
    this.widget.GetItem("name").Text = _name; 
    this.widget.GetItem("id").Text = _id;
    
    //check which alarm modes is needed, add them in this.modes
    //add in btnNames custom names of alarm modes
    for (var i = 0; i < 4; i++){
        if (_modes[i] == 1){
            this.modes.push("btn" + i);
            this.btnNames.push(_btnNames[i]);
        }
    }
   
    //buttons width and position, depending of how many muttons is needed
    var settings = {
        1:    {"coord": [32],                 "width": 576 },
        2:    {"coord": [32, 318],            "width": 288},
        3:    {"coord": [32, 224, 416],       "width": 192},
        4:    {"coord": [32, 176, 318, 462],  "width": 144}}   
    
    var width = settings[this.modes.length]["width"];    //width of each button
    var coord = settings[this.modes.length]["coord"];    //position for each button    
    var buttonsCount = this.modes.length;                //amount of buttons
                  
    for (var i = 0; i < buttonsCount; i++){
        var button = this.widget.GetItem(this.modes[i]);
        button.Width = width;
        button.X = coord[i];
        button.Visible = true;
        button.Text = this.btnNames[i];
        
        //changing button properties
        switch (buttonsCount){
            case 1:
                button.GetState(0).Border = 8;
                button.GetState(1).Border = 8;
                break;  
            case 2:
                //if buttonsCount is equal to 2, show vertical separator between buttons
                this.widget.GetItem("vertical line").Visible = true;
                switch (i){
                    case 0:
                        button.GetState(0).Border = 113;
                        button.GetState(1).Border = 113;
                        break;
                    case 1:
                        button.GetState(0).Border = 94;
                        button.GetState(1).Border = 94;
                        break;               
                }
                break;
            case 3:
                switch (i){
                    case 0:
                        button.GetState(0).Border = 113;
                        button.GetState(1).Border = 113;
                        break;
                    case 1:
                        button.GetState(0).Border = 4;
                        button.GetState(1).Border = 4;
                        break;
                    case 2:
                        button.GetState(0).Border = 94;
                        button.GetState(1).Border = 94;
                        break;               
                }
                break;
            case 4:
                switch (i){
                    case 0:
                        button.GetState(0).Border = 113;
                        button.GetState(1).Border = 113;
                        break;
                    case 1 || 2:
                        button.GetState(0).Border = 4;
                        button.GetState(1).Border = 4;
                        break;
                    case 3:
                        button.GetState(0).Border = 94;
                        button.GetState(1).Border = 94;
                        break;               
                }
                break;
        }
    } 

    IR.AddListener(IR.EVENT_ITEM_PRESS, this.widget.GetItem("btn0"), function(){           
        this.send(0x80);
    }, this);
    IR.AddListener(IR.EVENT_ITEM_PRESS, this.widget.GetItem("btn1"), function(){
        this.send(0x81);
    }, this);
    IR.AddListener(IR.EVENT_ITEM_PRESS, this.widget.GetItem("btn2"), function(){
        this.send(0x82);
    }, this);
    IR.AddListener(IR.EVENT_ITEM_PRESS, this.widget.GetItem("btn3"), function(){
        this.send(0x83);
    }, this);

    _list.AddPopup(this.widget);
}

//==========================================================================================

Security.prototype.send = function(cmd){   
    var command = [];
    
    command.push(cmd);
            
    for (var i = 0; i < pass.length; i++){
        command.push(pass[i]);
    }
        
    for (var i = 0; i < this.data.length; i++){
        command.push(this.data[i]);
    }
    sendFrame(command);
}

//==========================================================================================

objSecurityModes = [    {cmd: 0x80, name: 'Mode 0'},
                        {cmd: 0x81, name: 'Mode 1'},
                        {cmd: 0x82, name: 'Mode 2'},
                        {cmd: 0x83, name: 'Mode 3'}   ]