function Temperature(_name, _id, in_satel) {
    this.name = 'temp_'+ _name + '_' + _id;
    //zone number 1-256 (send 0 instead of 256)
    this.id = _id == 256 ? 0 : _id;
    //satel object which contains Temperature widget
    this.satel = in_satel;
    
    //add temperature sensor ID to Satel
    if (this.satel.termoSensors.indexOf(this.id) == -1)
        this.satel.termoSensors.push(this.id);
    
    this.widget = IR.GetPopup("temperatureWidget").Clone('tempSens_' + _name + '_' + _id);
    this.value = this.widget.GetItem("value").GetState(0);

    this.widget.GetItem("name").Text = _name;
    this.widget.GetItem("id").Text = _id;
        
    IR.SetInterval(1000, function(){
        if (this.id in this.satel.recievedTSensors){
            var l_nValue = dataToTemp(this.satel.recievedTSensors[this.id]);
            this.value.Text = l_nValue + 'º';
            //=================FEEDBACK==========================================
             IR.GetDevice('Custom Driver').SetFeedback(this.name, l_nValue);
            //===================================================================
        }
    }, this);
            
    this.satel.mainList.AddPopup(this.widget);
    
};

//==========================================================================================
//convert binary data to temperature
function dataToTemp(_data){
    var high = _data[0] << 2;
    var low = _data[1];
    var data = high + low;
    var temp = -55.0 + (0.5 * data);
    return temp;
}

//==========================================================================================
//generate command to sent: 0x17 + user password + data
function createTempCommand(in_nId){
    var command = [];
    
    command.push(0x7D);
      
    if (in_nId == 256){
        command.push(0x00)
    } else {
        command.push(in_nId);
           
    return command;

    }
}